#include "PDFLibrary.ts"
#include "TexasCommon.ts"

#version 1.0.2

public printTask(variable parameters) {
	PDFDocument pdf;
	Integer maxWidth, maxHeight, position = 717, temp;
	AString string;
	pdf.SelectDraw(1,-1,-1,-1,205,205,205);
	pdf.DrawRectangle(40,780,515,22,PDFDocument .PATH_STROKE_FILL);
	pdf.SelectFont(PDFDocument .FONT_HELVETICA_BI,14,-1,-1,-1,-1,0);
	pdf.WriteText("Task Identifiers",50,785);
	pdf.SelectFont(PDFDocument .FONT_HELVETICA_BOLD,12);
	pdf.WriteText("Number:",50,765);
	pdf.WriteText("Project:",50,750);
	pdf.WriteText("Name:",50,735);
	pdf.WriteText("Description:",50,720);
	pdf.TextExtent(parameters.Description,435,0:maxWidth,maxHeight);
	pdf.WriteText("Duration:",50,(position -= maxHeight));
	if(parameters.Flags & 0x1000)//has due period
		pdf.WriteText("Due Period:",50,(position -= 15));
	pdf.WriteText("Budgeted:",50,(position -= 15));
	pdf.SelectFont(PDFDocument .FONT_HELVETICA);
	pdf.WriteText(parameters.Code,145,765);
	pdf.WriteText(parameters.ProjectName,145,750);
	pdf.WriteText(parameters.Name,145,735);
	pdf.WriteText(parameters.Description,145,732-maxHeight,415);
	durationToString(parameters.Duration, parameters.Flags.Integer() : string);
	if(parameters.Flags & 0x1000){//has due period	
		pdf.WriteText(string,145,position+30);
		durationToString(parameters.DuePeriod, parameters.Flags.Integer() >> 8: string);
		pdf.WriteText(string,145,position+15);
	}
	else pdf.WriteText(string,145,position+15);
	currencyToString(parameters.Budgeted : string);
	pdf.WriteText(string,145,position);
	pdf.SelectDraw(1,-1,-1,-1,205,205,205);
	position -= 35;
	pdf.DrawRectangle(40,position,515,22,PDFDocument .PATH_STROKE_FILL);
	pdf.SelectFont(PDFDocument .FONT_HELVETICA_BI,14,-1,-1,-1,-1,0);
	pdf.WriteText("Task Schedule",50,position + 5);
	pdf.SelectFont(PDFDocument .FONT_HELVETICA_BOLD,12);
	pdf.WriteText("Authorised By:",50,position - (temp = 15));
	pdf.WriteText("Priority:",50,position - (temp += 15));
	if(parameters.Flags & 0x40) pdf.WriteText("Wait Until:",50,position - (temp += 15));
	if(parameters.Flags & 0x10){
		pdf.WriteText("Started:",50,position - (temp += 15));
		pdf.WriteText("Started By:",50,position - (temp += 15));
	}
	if(parameters.Flags & 0x20){
		pdf.WriteText("Finished:",50,position - (temp += 15));
		pdf.WriteText("Out Come:",50,position - (temp += 15));
	}
	pdf.SelectFont(PDFDocument .FONT_HELVETICA);
	pdf.WriteText(parameters.AuthorisedByName,145,(position -= 15));
	pdf.WriteText(parameters.Prority.ToString(),145,(position -= 15));
	if(parameters.Flags & 0x40) pdf.WriteText(parameters.WaitUntil.ToString(),145,(position -= 15));
	if(parameters.Flags & 0x10){
		pdf.WriteText(parameters.Start.ToString(),145,(position -= 15));
		for(string = parameters.Entity[0].EntityName, temp = 1; temp < parameters.EntityCount; temp++)
			string += " and " + parameters.Entity[temp].EntityName;
		pdf.WriteText(string,145,(position -= 15));
	}
	if(parameters.Flags & 0x20){
		pdf.WriteText(parameters.Finish.ToString(),145,(position -= 15));
		pdf.WriteText(parameters.OutCome,145,(position -= 15));
	}
	position -= 35;
	if(parameters.Dependency.length > 0){
		pdf.DrawRectangle(40,position,515,22,PDFDocument .PATH_STROKE_FILL);
		pdf.SelectFont(PDFDocument .FONT_HELVETICA_BI,14,-1,-1,-1,-1,0);
		pdf.WriteText("Task Dependencies",50,position + 5);
		pdf.SelectFont(PDFDocument .FONT_HELVETICA_BOLD,12);
		position -= 15;
		for(Integer count = 0; count < parameters.Dependency.length; count++){
			if(parameters.Dependency[count].Type == 0) pdf.WriteText("Entities:",50,position-(15*count));
			else if(parameters.Dependency[count].Type == 1) pdf.WriteText("Entity Category:",50,position-(15*count));
			else pdf.WriteText("Unknown:",50,position-(15*count));
		}
		pdf.SelectFont(PDFDocument .FONT_HELVETICA,12);
		for(Integer count = 0; count < parameters.Dependency.length; count++, position -= 15){
			string = parameters.Dependency[count].IDList[0].Name;
			for(Integer count1 = 1; count1 < parameters.Dependency[count].IDList.length; count1++)
				string += ", " + parameters.Dependency[count].IDList[count1].Name;
			pdf.WriteText(string,145,position,415,12);
		}
		position -= 20;//for loop minus' 15
	}
	if(parameters.History.length > 0){
		pdf.DrawRectangle(40,position,515,22,PDFDocument .PATH_STROKE_FILL);
		pdf.SelectFont(PDFDocument .FONT_HELVETICA_BI,14,-1,-1,-1,-1,0);
		pdf.WriteText("Task Suspension History",50,position + 5);
		pdf.SelectFont(PDFDocument .FONT_HELVETICA,12);
		position -= 15;
		temp = parameters.Start;
		pdf.SelectDraw(.5);
		for(Integer count = 0; count < parameters.History.length; count++){
			pdf.WriteText(temp.ToString() + " to " + parameters.History[count].Suspended.ToString(),50,position);
			if(parameters.History[count].Comment != ""){
				pdf.TextExtent("Result: " + parameters.History[count].Comment,495:maxWidth,maxHeight);
				pdf.WriteText("Result: " + parameters.History[count].Comment,50,position-maxHeight-3,495,maxHeight);
				position -= (maxHeight + 23);
			}
			else position -= 23;
			pdf.StartPath(50,position+15);
			pdf.DrawLineTo(545,position+15);
			temp = parameters.History[count].Resumed;
		}
		if(parameters.Flags & 0x20){
			pdf.WriteText(temp.ToString() + " to " + parameters.Finish.ToString(),50,position);
			if(parameters.OutCome != ""){
				pdf.TextExtent("Result: " + parameters.OutCome,495:maxWidth,maxHeight);
				pdf.WriteText("Result: " + parameters.OutCome,50,position-maxHeight-3,495,maxHeight);
				position -= (maxHeight + 23);
			}
			else position -= 23;
			pdf.StartPath(50,position+15);
			pdf.DrawLineTo(545,position+15);
		}
	}
	pdf.SaveDocument("task.pdf");
}

